/*******************************************************************************

  Copyright (c) Odin TeleSystems Inc., 2004, All Rights Reserved.

  Odin TeleSystems Inc.

  OTX Telecom Adapter Driver

  @doc PublicDemo

  @module

    OtxBurstStatsDlg.cpp

    A simple example Windows application demonstrating the use of OTX
    Driver with the Plus cards.

    The sample application provides a simple windows gui interface which
    demostrates one of the many ways to implement a windows application.
    This demo is a simple Microsoft MFC dialog based application that
    presents a list of Burst capable devices that are found in the machine
    and displays the Burst statistics.

*******************************************************************************/

// OtxBurstStatsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OtxBurstStats.h"
#include "OtxBurstStatsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COtxBurstStatsDlg dialog

COtxBurstStatsDlg::COtxBurstStatsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COtxBurstStatsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COtxBurstStatsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void COtxBurstStatsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COtxBurstStatsDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COtxBurstStatsDlg, CDialog)
	//{{AFX_MSG_MAP(COtxBurstStatsDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COtxBurstStatsDlg message handlers

BOOL COtxBurstStatsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
  OTX_RESULT OtxResult;

  hBurst = OTX_INVALID_HANDLE_VALUE;

  OtxResult = OtxDrvConnectLib();
  if (OtxResult != OTX_S_OK) {
    switch (OTX_RESULT_CODE(OtxResult)) {
    case OTX_RES_HANDLE:
      AfxMessageBox("Error: Could not connect to the OTX library.\nPossible cause: OTX Driver not loaded\n", MB_OK | MB_ICONERROR);
      OtxDrvReleaseLib();
      break;
    case OTX_RES_NOT_SUPPORTED:
      AfxMessageBox("Error: Mismatch between OTX Driver revision and OTX Library revision.\nRevisions must match.", MB_OK | MB_ICONERROR);
      break;
    default:
      ReportError(OTX_INVALID_HANDLE_VALUE, OtxResult);
      break;
    }

    return TRUE;
  }

  Fill_cbOtxDevices();

  SetTimer(1, 1000, NULL);
  
  return TRUE;  // return TRUE  unless you set the focus to a control
}

void COtxBurstStatsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COtxBurstStatsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR COtxBurstStatsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void COtxBurstStatsDlg::FormatTimeStamp(OTX_DATETIME nTimeStamp, CString &s)
{
  OTX_DATETIME nTimeStampMs;
  OTX_DATETIME nTimeStampSec;
  struct Osa_tm *ptCurrentDayAndTime;
  Osa_time_t nCurrentTimeSecs;

  // Subtract number of 100ns ticks between Jan 1, 1970 and Jan 1, 1600
  nTimeStamp.nUint64 = nTimeStamp.nUint64 - 116444736000000000;

  // Convert to seconds since Jan 1, 1970 (so we can use this time with OsaStdLocalTime())
  nTimeStampSec.nUint64 = nTimeStamp.nUint64 / 10000000;

  // Calculate number of milliseconds (since number of seconds is not a very accurate way to report timestamp)
  nTimeStampMs.nUint64 = nTimeStamp.nUint64 / 10000 - (nTimeStampSec.nUint64 * 1000);

  nCurrentTimeSecs = nTimeStampSec.sUint32.nLow;
  ptCurrentDayAndTime = OsaStdLocalTime(&nCurrentTimeSecs);

  if (ptCurrentDayAndTime) {
    s.Format("%.2d-%.2d %.2d:%.2d:%.2d.%.3d",
      ptCurrentDayAndTime->tm_mon + 1,
      ptCurrentDayAndTime->tm_mday,
      ptCurrentDayAndTime->tm_hour,
      ptCurrentDayAndTime->tm_min,
      ptCurrentDayAndTime->tm_sec,
      nTimeStampMs.sUint32.nLow
    );
  } else {
    s.Format("Error: Invalid timestamp (before Jan 1, 1970)");
  }
}

void COtxBurstStatsDlg::OnTimer(UINT nIDEvent) 
{
  OTX_UINT32        stat_Starts;          // Number of actual dma transfers initiated
  OTX_UINT32        stat_Completes;       // Number of actual dma transfers completed
  OTX_UINT32        stat_Partial;         // Number of partial transfer due to framemask
  OTX_UINT32        stat_Full;            // Number of count of max dma size transfers
  OTX_UINT32        stat_Aborts;          // Number of actual dma transfers aborts
  OTX_UINT32        stat_Amount;          // Number of amount of data transfered
  OTX_UINT32        stat_Errors;          // Number of count of processing errors
  OTX_UINT32        stat_OUruns;          // Number of amount of over/under runs
  OTX_UINT32        stat_OUrunsUser;      // Number of amount of over/under runs caused by user mode
  OTX_UINT32        stat_DmaBusy;         // Number of count of DMA busy occurances
  OTX_UINT32        stat_Notify;          // Number of logical device notifies
  OTX_UINT32        stat_NotifyPartial;   // Number of logical device notifies - partial

  OTX_UINT32                ui32;
  OtxBurstFrameRefAndTime   FrameRef;             // frame reference data
  static OTX_UINT64         nLastFrame = 0;
  
  CString s;

  if (hBurst == OTX_INVALID_HANDLE_VALUE) {
    return;
  }

  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_STARTS,         &stat_Starts        );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_COMPLETES,      &stat_Completes     );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_PARTIAL,        &stat_Partial       );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_FULL,           &stat_Full          );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_ABORTS,         &stat_Aborts        );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_AMOUNT,         &stat_Amount        );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_ERRORS,         &stat_Errors        );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_OURUNS,         &stat_OUruns        );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_OURUNS_USER,    &stat_OUrunsUser    );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_DMABUSY,        &stat_DmaBusy       );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_NOTIFY,         &stat_Notify        );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_RECV_NOTIFY_PARTIAL, &stat_NotifyPartial );

  s.Format("%u", stat_Starts        ); GetDlgItem(IDC_EDIT25)->SetWindowText(s);
  s.Format("%u", stat_Completes     ); GetDlgItem(IDC_EDIT26)->SetWindowText(s);
  s.Format("%u", stat_Partial       ); GetDlgItem(IDC_EDIT27)->SetWindowText(s);
  s.Format("%u", stat_Full          ); GetDlgItem(IDC_EDIT28)->SetWindowText(s);
  s.Format("%u", stat_Aborts        ); GetDlgItem(IDC_EDIT29)->SetWindowText(s);
  s.Format("%u", stat_Amount        ); GetDlgItem(IDC_EDIT30)->SetWindowText(s);
  s.Format("%u", stat_Errors        ); GetDlgItem(IDC_EDIT31)->SetWindowText(s);
  s.Format("%u", stat_OUruns        ); GetDlgItem(IDC_EDIT32)->SetWindowText(s);
  s.Format("%u", stat_OUrunsUser    ); GetDlgItem(IDC_EDIT33)->SetWindowText(s);
  s.Format("%u", stat_DmaBusy       ); GetDlgItem(IDC_EDIT34)->SetWindowText(s);
  s.Format("%u", stat_Notify        ); GetDlgItem(IDC_EDIT35)->SetWindowText(s);
  s.Format("%u", stat_NotifyPartial ); GetDlgItem(IDC_EDIT36)->SetWindowText(s);

  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_STARTS,         &stat_Starts        );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_COMPLETES,      &stat_Completes     );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_PARTIAL,        &stat_Partial       );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_FULL,           &stat_Full          );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_ABORTS,         &stat_Aborts        );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_AMOUNT,         &stat_Amount        );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_ERRORS,         &stat_Errors        );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_OURUNS,         &stat_OUruns        );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_OURUNS_USER,    &stat_OUrunsUser    );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_DMABUSY,        &stat_DmaBusy       );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_NOTIFY,         &stat_Notify        );
  OtxDrvGetAttributeValueUint32(hBurst, OTX_ATTR_BURST_STAT_SEND_NOTIFY_PARTIAL, &stat_NotifyPartial );

  s.Format("%u", stat_Starts        ); GetDlgItem(IDC_EDIT13)->SetWindowText(s);
  s.Format("%u", stat_Completes     ); GetDlgItem(IDC_EDIT14)->SetWindowText(s);
  s.Format("%u", stat_Partial       ); GetDlgItem(IDC_EDIT15)->SetWindowText(s);
  s.Format("%u", stat_Full          ); GetDlgItem(IDC_EDIT16)->SetWindowText(s);
  s.Format("%u", stat_Aborts        ); GetDlgItem(IDC_EDIT17)->SetWindowText(s);
  s.Format("%u", stat_Amount        ); GetDlgItem(IDC_EDIT18)->SetWindowText(s);
  s.Format("%u", stat_Errors        ); GetDlgItem(IDC_EDIT19)->SetWindowText(s);
  s.Format("%u", stat_OUruns        ); GetDlgItem(IDC_EDIT20)->SetWindowText(s);
  s.Format("%u", stat_OUrunsUser    ); GetDlgItem(IDC_EDIT21)->SetWindowText(s);
  s.Format("%u", stat_DmaBusy       ); GetDlgItem(IDC_EDIT22)->SetWindowText(s);
  s.Format("%u", stat_Notify        ); GetDlgItem(IDC_EDIT23)->SetWindowText(s);
  s.Format("%u", stat_NotifyPartial ); GetDlgItem(IDC_EDIT24)->SetWindowText(s);

  OTX_DATETIME dt;
  OtxDrvGetCurrentTime(&dt);
  FormatTimeStamp(dt, s); GetDlgItem(IDC_EDIT39)->SetWindowText(s);

  OtxDrvGetAttributeValue(hBurst, OTX_ATTR_BURST_GET_FRAME_REF_DATA, &FrameRef, sizeof(FrameRef), &ui32);
  // just skip if we wrapped
  if (FrameRef.m_FrameCounter > nLastFrame) {
    FormatTimeStamp(FrameRef.m_FrameDateTime, s); GetDlgItem(IDC_EDIT37)->SetWindowText(s);
    s.Format("%08x%08x", (OTX_UINT32) (FrameRef.m_FrameCounter >> 32), (OTX_UINT32) (FrameRef.m_FrameCounter)); GetDlgItem(IDC_EDIT38)->SetWindowText(s);
  }
  nLastFrame = FrameRef.m_FrameCounter;
}

void COtxBurstStatsDlg::Fill_cbOtxDevices()
{
  OTX_RESULT OtxResult;
  OTX_ITERATOR itrChildTypes, itrChildrenOfSameType;
  OTX_INT32  hParentDevice;
  OTX_UINT32 hChildDevice;
  OtxPhysicalDeviceTypeE eDevType;
    
  CComboBox *cbOtxDevices;

  cbOtxDevices = (CComboBox *) GetDlgItem(IDC_COMBO1);
  cbOtxDevices->ResetContent();
    
  hParentDevice = 0;

  OtxDrvIteratorBegin(&itrChildTypes);
  while (OtxDrvEnumDeviceType(hParentDevice, &itrChildTypes, (OTX_INT32 *) &eDevType) == OTX_S_OK) {
    CString sDevNo, sDevType;
    OTX_UINT32 nDevNo;
      
    OtxDrvIteratorBegin(&itrChildrenOfSameType);
    while (OtxDrvEnumDevice(hParentDevice, eDevType, &itrChildrenOfSameType, &hChildDevice) == OTX_S_OK) {
      if (hChildDevice != OTX_INVALID_HANDLE_VALUE) {
        int nIndex;

        OtxResult = OtxDrvGetAttributeValueUint32(hChildDevice, OTX_ATTR_DEVICE_NO, &nDevNo);
        if (! OTX_SUCCESS(OtxResult)) {
          nDevNo = -1;
        }

        sDevNo.Format("[%d]", nDevNo);
        sDevType.Format("(%d)", eDevType);

        switch (eDevType) {
        case OTX_DEVICE_GIMLE_16_PCI_PLUS:
          nIndex = cbOtxDevices->AddString(sDevNo + " GIMLE_16_PCI " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_THOR_8_PCI_PLUS:
          nIndex = cbOtxDevices->AddString(sDevNo + " THOR_8_PCI_PLUS " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_THOR_2_PCI_PLUS:
          nIndex = cbOtxDevices->AddString(sDevNo + " THOR_2_PCI_PLUS " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_THOR_4_PCI_PLUS:
          nIndex = cbOtxDevices->AddString(sDevNo + " THOR_4_PCI_PLUS " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        case OTX_DEVICE_SLEIPNIR_1_PCI:
          nIndex = cbOtxDevices->AddString(sDevNo + " SLEIPNIR_1_PCI " + sDevType);
          cbOtxDevices->SetItemData(nIndex, hChildDevice);
          break;
        default:
          break;
        }
      }
    }
  }
    
  if (cbOtxDevices->GetCount() > 0) {
    cbOtxDevices->SetCurSel(0);
    OnSelchangeCombo1() ;
  }

}

void COtxBurstStatsDlg::OnSelchangeCombo1() 
{
  OTX_INT32 nDevNo, nDevType;

  CString sDevNo, sDevType;
    
  CComboBox *cbOtxDevices;
  int nSelect;

  cbOtxDevices = (CComboBox *) GetDlgItem(IDC_COMBO1);

  nSelect = cbOtxDevices->GetCurSel();
  if (nSelect != CB_ERR) {
    CString s;

    cbOtxDevices->GetLBText(nSelect, s);

    sDevNo    = s.Mid(s.Find("[") + 1, s.Find("]") - 1);
    sDevType  = s.Mid(s.Find("(") + 1, s.Find(")") - 1);
    nDevNo    = atoi(sDevNo);
    nDevType  = atoi(sDevType);
    
    OTX_ITERATOR itrChildrenOfSameType;
    OTX_INT32  hParentDevice;
    OTX_UINT32 hChildDevice;
    OtxPhysicalDeviceTypeE eDevType;

    hBurst = OTX_INVALID_HANDLE_VALUE;

    eDevType = OTX_DEVICE_BURST;
    hParentDevice = (long) cbOtxDevices->GetItemData(nSelect);
    OtxDrvIteratorBegin(&itrChildrenOfSameType);
    while (OtxDrvEnumDevice(hParentDevice, eDevType, &itrChildrenOfSameType, &hChildDevice) == OTX_S_OK) {
      if (hChildDevice != OTX_INVALID_HANDLE_VALUE) {
        hBurst = hChildDevice;
        break;
      }
    }

  }
}

void COtxBurstStatsDlg::ReportError(OTX_HANDLE hDev, OTX_RESULT resErr)
{
  CString str;

  if (OtxDrvResultCode2String(hDev, resErr, 256, str.GetBuffer(256)) != OTX_S_OK) {
    str = "Unknown Error!";
  }
  str.Format("%s\n(ref: 0x%x [%d.%d])", str, OTX_RESULT_CODE(resErr), OTX_RESULT_SOURCE_ID(resErr), OTX_RESULT_LINE_NUM(resErr));
  str.ReleaseBuffer();

  AfxMessageBox(str, MB_OK | MB_ICONERROR);
}


void COtxBurstStatsDlg::OnClose() 
{
  OtxDrvReleaseLib();
	
	CDialog::OnClose();
}

void COtxBurstStatsDlg::OnButton1() 
{
  if (hBurst != OTX_INVALID_HANDLE_VALUE) {
    OtxDrvDbgDump(hBurst, 101);   // reset stats
  }
}
