/*******************************************************************************

  Copyright (c) Odin TeleSystems Inc., 2004, All Rights Reserved.

  Odin TeleSystems Inc.

  OTX Telecom Adapter Driver

  @doc PublicDemo

  @module

    OtxBurstStatsDlg.h

    A simple example Windows application demonstrating the use of OTX
    Driver with the Plus cards.

    The sample application provides a simple windows gui interface which
    demostrates one of the many ways to implement a windows application.
    This demo is a simple Microsoft MFC dialog based application that
    presents a list of Burst capable devices that are found in the machine
    and displays the Burst statistics.

*******************************************************************************/

// OtxBurstStatsDlg.h : header file
//

#if !defined(AFX_OTXBURSTSTATSDLG_H__945CB157_BD98_43D3_A194_9B3414EA1BA9__INCLUDED_)
#define AFX_OTXBURSTSTATSDLG_H__945CB157_BD98_43D3_A194_9B3414EA1BA9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// OTX SDK headers
#include "OsaStd.h"
#include "OtxErr.h"
#include "OtxDrv.h"
#include "OtxBurst.h"
#include "OtxBurstD.h"

/////////////////////////////////////////////////////////////////////////////
// COtxBurstStatsDlg dialog

class COtxBurstStatsDlg : public CDialog
{
// Construction
public:
	COtxBurstStatsDlg(CWnd* pParent = NULL);	// standard constructor

  void Fill_cbOtxDevices();
  void ReportError(OTX_HANDLE hDev, OTX_RESULT resErr);
  void FormatTimeStamp(OTX_DATETIME nTimeStamp, CString &s);

  OTX_HANDLE hBurst;

// Dialog Data
	//{{AFX_DATA(COtxBurstStatsDlg)
	enum { IDD = IDD_OTXBURSTSTATS_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COtxBurstStatsDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(COtxBurstStatsDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSelchangeCombo1();
	afx_msg void OnClose();
	afx_msg void OnButton1();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OTXBURSTSTATSDLG_H__945CB157_BD98_43D3_A194_9B3414EA1BA9__INCLUDED_)
